SystemOrganization addCategory: #'TaskScheduler-MultipleWorlds'!

Task subclass: #LocalTask
	instanceVariableNames: 'world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TaskScheduler-MultipleWorlds'!

!LocalTask commentStamp: 'HenrikSperreJohansen 1/23/2012 14:22' prior: 0!
By default, Pharo does not include multiple World support anymore, so only use this if you have an external package which does (and raise appropriate Announcements when Worlds change)

LocalTask is a task local to a specific World, providing updates equivalent to the traditional local stepping.

When its world is no longer the current World, it ejects itself from the scheduled tasks.
When the world changes back to local World, it reinserts itself.!

!LocalTask methodsFor: 'dispatch' stamp: 'HenrikSperreJohansen 1/23/2012 16:29'!
addTo: aTaskList
	
	"This will probably be changed to work with Multiple World support in 	http://www.squeaksource.com/TilingWindowManager as soon as it supports announcements"
	"Subscribe with world manager to be active only when my world is the current one"
	"WorldManager instance" world subscribe: "WorldChanged"WindowActivated  
		do: [:ann | 
			ann to = world ifTrue: [aTaskList add: self].
			ann from = world ifTrue: [aTaskList remove: self]] .
	^super addTo: aTaskList! !

!LocalTask methodsFor: 'initialize-release' stamp: 'HenrikSperreJohansen 1/23/2012 14:13'!
initialize
	super initialize.
	world := UIManager currentWorld.
	
	! !
